using System.Collections.Generic;
using NUnit.Framework;
using Rhino.Mocks;

namespace Lists.Web.Controls.Test
{
    [TestFixture]
    public class LookupCollectionTest
    {
        private MockRepository mockery;

        [SetUp]
        public void Setup()
        {
            mockery = new MockRepository();
        }

        [TearDown]
        public void TearDown()
        {
            mockery.VerifyAll();
        }

        [Test]
        public void ShouldBindToLookupList()
        {
            ILookupList mockLookupList = mockery.CreateMock<ILookupList>();
            IList<ILookupDTO> mockLookupDTOS = new List<ILookupDTO>();

            for (int i = 0; i < 5; i++)
            {
                mockLookupDTOS.Add(mockery.CreateMock<ILookupDTO>());
            }
            
            using (mockery.Ordered())
            {
               mockLookupList.Clear();
                
               mockLookupList.Add(null);

               LastCall.Constraints(Is.NotNull() & Is.TypeOf(typeof(ILookupDTO)));
               LastCall.Repeat.Times(5);
            }
            
            mockery.ReplayAll();
            
            LookupCollection collection = new LookupCollection(mockLookupDTOS);
            collection.BindTo(mockLookupList);
            
            
        }
    }
}